<template>
  <div class="page-container">
    <form
      @submit="mySubmit"
      class="d-flex flex-column card-form p-20 radius responsive_form"
    >
      <h2>Modifier un aliment</h2>

      <div class="wrapper d-flex">
        <div class="left">
          <div class="p-10 d-flex flex-column">
            <label>Nom</label>
            <input
              v-model="nameValue"
              type="text"
              class="input radius"
              required
            />
          </div>

          <div class="p-10 d-flex flex-column">
            <label>Catégorie</label>
            <select v-model="typeValue" class="radius" required>
              <option disabled value="">Choisissez</option>
              <option value="viande">Viande</option>
              <option value="fruit">Fruit</option>
              <option value="legume">Légume</option>
              <option value="fromage">Fromage</option>
              <option value="poisson">Poisson</option>
              <option value="boisson">Boisson</option>
              <option value="produits laitiers">Produits laitiers</option>
              <option value="condiment">Condiment</option>
            </select>
          </div>

          <div class="p-10 d-flex flex-column">
            <label>Quantité</label>
            <input
              v-model="quantityValue"
              type="number"
              class="input radius"
              required
            />
          </div>
        </div>

        <div class="right">
          <div class="p-10 d-flex flex-column">
            <label>Date de péremption</label>
            <input
              v-model="expirationAlertValue"
              type="date"
              class="input radius"
              required
            />
          </div>

          <div class="p-10 d-flex flex-column">
            <label>Stock minimum</label>
            <input
              v-model="limitQuantityValue"
              type="number"
              class="input radius"
            />
          </div>
        </div>
      </div>

      <button class="button radius">Ajouter</button>
    </form>
  </div>
</template>

<script setup lang="ts">
import { useForm, useField } from "vee-validate";
import { useUser } from "../../shared/stores/index";
import { useRouter, useRoute } from "vue-router";
import { onMounted } from "vue";
import type { Product } from "@/shared/interfaces";

const router = useRouter();
const route = useRoute()
const id = route.params.id;
const BASE_URL = import.meta.env.VITE_BASE_URL;


const { handleSubmit } = useForm();
const mySubmit = handleSubmit(async (value) => {
  const UserStore = useUser();
  console.log(value);
  try {
    const response = await fetch(BASE_URL + "products/"+id, {
      method: "PUT",
      body: JSON.stringify(value),
      headers: {
        "Content-Type": "application/json",
        authorization: `Bearer ${UserStore.token}`,
      },
    });
  } catch (e) {
    console.log(e);
  }
  router.push("/dashboard");
});

const { value: nameValue } = useField("name");
const { value: typeValue } = useField("type");
const { value: quantityValue } = useField("quantity");
const { value: limitQuantityValue } = useField("limit_quantity");
const { value: expirationAlertValue } = useField("expiration_alert");
onMounted(()=>{
  fetch(BASE_URL + "products/"+id)
  .then(res=>res.json())
  .then((product:Product)=>{
    nameValue.value = product.name
    typeValue.value = product.type
    quantityValue.value = product.quantity
    limitQuantityValue.value = product.ProductAlert?.limit_quantity
    if(product.ExpirationAlert?.expiration_alert){
      const d = new Date(product.ExpirationAlert?.expiration_alert)
      let temp = d.getFullYear().toString()
      if(d.getMonth() +1 >= 10)
        temp += "-" + (d.getMonth() +1)
      else{
        temp += "-0" + (d.getMonth() +1)
      }
      if(d.getDate() >= 10)
        temp += "-" + d.getDate()
      else{
        temp += "-0" + d.getDate()
      }
      expirationAlertValue.value = temp
    }
    console.log(expirationAlertValue.value)
  })
})
</script>

<style scoped lang="scss">
form {
  height: auto;
  margin: auto;
  width: 450px;
}

@media screen and (max-width: 500px) {
  form {
    width: calc(100% - 30px);
  }
}

@media screen and (max-width: 450px) {
  .d-flex {
    flex-direction: column;
  }
}

label {
  padding-bottom: 5px;
}

select {
  padding: 2.5px;
  border: 1px solid #c8c8c8;
}

select:focus {
  outline: solid #0097e6;
}

button {
  margin: 10px;
}
</style>
